]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame_incremental - builder.sh
- install link to mirrors file
[packages/rpm-build-tools.git] / builder.sh
... / ...
CommitLineData
1#!/bin/ksh
2#
3# This program is free software, distributed under the terms of
4# the GNU General Public License Version 2.
5#
6# -----------
7# Exit codes:
8# 0 - succesful
9# 1 - help displayed
10# 2 - no spec file name in cmdl parameters
11# 3 - spec file not stored in repo
12# 4 - some source, patch or icon files not stored in repo
13# 5 - package build failed
14# 6 - spec file with errors
15# 7 - wrong source in /etc/poldek.conf
16# 8 - Failed installing buildrequirements and subrequirements
17# 9 - Requested tag already exist
18# 10 - Refused to build fractional release
19# 100 - Unknown error (should not happen)
20# 110 - Functions not yet implemented
21
22# Notes (todo/bugs):
23# - when Icon: field is present, -5 and -a5 doesn't work
24# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
25# - does not respect NoSource: X, and tries to cvs up such files [ example: VirtualBox-bin.spec and its Source0 ]
26# TODO:
27# - ability to do ./builder -bb foo.spec foo2.spec foo3.spec
28# - funny bug, if source-md5 is set then builder will download from distfiles even if there is no url present:
29# Source10: forwardfix.pl
30# # Source10-md5: 8bf85f7368933a4e0cb4f875bac28733
31# - builder --help:
32# basename: missing operand
33# Try `basename --help' for more information.
34# -- and the normal usage info --
35
36PROGRAM=${0##*/}
37APPDIR=$(d=$0; [ -L "$d" ] && d=$(readlink -f "$d"); dirname "$d")
38RCSID='$Id: builder,v 1.645 2011/02/13 17:54:10 glen Exp $' r=${RCSID#* * } rev=${r%% *}
39VERSION="v0.35/$rev"
40VERSIONSTRING="\
41Build package utility from PLD Linux Packages repository
42$VERSION (C) 1999-2012 Free Penguins".
43
44PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
45
46# required rpm-build-macros
47RPM_MACROS_VER=1.534
48
49COMMAND="build"
50TARGET=""
51
52SPECFILE=""
53BE_VERBOSE=""
54QUIET=""
55CLEAN=""
56DEBUG=""
57NOURLS=""
58NOCVSSPEC=""
59NODIST=""
60NOINIT=""
61PREFMIRRORS=""
62UPDATE=""
63ADD5=""
64NO5=""
65ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
66
67# use rpm 4.4.6+ digest format instead of comments if non-zero
68USEDIGEST=
69
70# user agent when fetching files
71USER_AGENT="PLD/Builder($VERSION)"
72
73# It can be used i.e. in log file naming.
74# See LOGFILE example.
75DATE=`date +%Y-%m-%d_%H-%M-%S`
76
77# target arch, can also be used for log file naming
78TARGET=$(rpm -E %{_target})
79
80# Example: LOGFILE='../log.$PACKAGE_NAME'
81# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
82# Example: LOGFILE='$PACKAGE_NAME/$PACKAGE_NAME.$DATE.log'
83# Example: LOGFILE='$PACKAGE_NAME.$DATE.log'
84# Yes, you can use variable name! Note _single_ quotes!
85LOGFILE=''
86
87LOGDIR=""
88LOGDIROK=""
89LOGDIRFAIL=""
90LASTLOG_FILE=""
91
92CHMOD="no"
93CHMOD_MODE="0644"
94RPMOPTS=""
95RPMBUILDOPTS=""
96BCOND=""
97GROUP_BCONDS="no"
98
99# create symlinks for tools in PACKAGE_DIR, see get_spec()
100SYMLINK_TOOLS="no"
101
102PATCHES=""
103SOURCES=""
104ICONS=""
105PACKAGE_RELEASE=""
106PACKAGE_VERSION=""
107PACKAGE_NAME=""
108ASSUMED_NAME=""
109PROTOCOL="http"
110
111# use lftp by default when available
112USE_LFTP=
113lftp --version > /dev/null 2>&1 && USE_LFTP=yes
114PARALLEL_DOWNLOADS=10
115
116WGET_RETRIES=${MAX_WGET_RETRIES:-0}
117
118CVS_FORCE=""
119CVSIGNORE_DF="yes"
120CVSTAG=""
121GIT_SERVER="git://git.pld-linux.org"
122GIT_PUSH="git@git.pld-linux.org"
123PACKAGES_DIR="packages"
124HEAD_DETACHED=""
125DEPTH=""
126ALL_BRANCHES=""
127REMOTE_PLD="origin"
128NEW_REPO=""
129
130RES_FILE=""
131
132DISTFILES_SERVER="://distfiles.pld-linux.org"
133ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
134
135DEF_NICE_LEVEL=19
136SCHEDTOOL="auto"
137
138FAIL_IF_NO_SOURCES="yes"
139
140# let get_files skip over files which are present to get those damn files fetched
141SKIP_EXISTING_FILES="no"
142
143TRY_UPGRADE=""
144# should the specfile be restored if upgrade failed?
145REVERT_BROKEN_UPGRADE="yes"
146
147if rpm --specsrpm 2>/dev/null; then
148 FETCH_BUILD_REQUIRES_RPMSPECSRPM="yes"
149 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
150else
151 FETCH_BUILD_REQUIRES_RPMSPECSRPM="no"
152 if [ -x /usr/bin/rpm-getdeps ]; then
153 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
154 else
155 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
156 fi
157fi
158
159UPDATE_POLDEK_INDEXES_OPTS=""
160
161# Here we load saved user environment used to
162# predefine options set above, or passed to builder
163# in command line.
164# This one reads global system environment settings:
165if [ -f ~/etc/builderrc ]; then
166 . ~/etc/builderrc
167fi
168# And this one cascades settings using user personal
169# builder settings.
170# Example of ~/.builderrc:
171#
172#UPDATE_POLDEK_INDEXES="yes"
173#UPDATE_POLDEK_INDEXES_OPTS="--mo=nodiff"
174#FETCH_BUILD_REQUIRES="yes"
175#REMOVE_BUILD_REQUIRES="force"
176#GROUP_BCONDS="yes"
177#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
178#TITLECHANGE=no
179#
180SU_SUDO=""
181if [ -n "$HOME_ETC" ]; then
182 USER_CFG="$HOME_ETC/.builderrc"
183 BUILDER_MACROS="$HOME_ETC/.builder-rpmmacros"
184else
185 USER_CFG=~/.builderrc
186 BUILDER_MACROS=~/.builder-rpmmacros
187fi
188
189[ -f "$USER_CFG" ] && . "$USER_CFG"
190
191if [ "$SCHEDTOOL" = "auto" ]; then
192 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
193 SCHEDTOOL="schedtool -B -e"
194 else
195 SCHEDTOOL="no"
196 fi
197fi
198
199if [ -n "$USE_PROZILLA" ]; then
200 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
201 GETURI2="$GETURI"
202 OUTFILEOPT="-O"
203elif [ -n "$USE_AXEL" ]; then
204 GETURI="axel -a $AXEL_OPTS"
205 GETURI2="$GETURI"
206 OUTFILEOPT="-o"
207elif [ -n "$USE_LFTP" ]; then
208 GETURI=download_lftp
209 GETURI2=$GETURI
210 OUTFILEOPT=""
211else
212 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
213 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
214 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
215 WGET_OPTS="$WGET_OPTS --user-agent=$USER_AGENT"
216
217 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
218 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
219 OUTFILEOPT="-O"
220fi
221
222GETLOCAL="cp -a"
223
224if rpm --version 2>&1 | grep -q '4.0.[0-2]'; then
225 RPM="rpm"
226 RPMBUILD="rpm"
227else
228 RPM="rpm"
229 RPMBUILD="rpmbuild"
230fi
231
232#
233# sanity checks
234#
235if [ -d $HOME/rpm/SOURCES ]; then
236 echo "ERROR: ~/rpm/{SPECS,SOURCES} structure is obsolete" >&2
237 echo "ERROR: get rid of your ~/rpm/SOURCES" >&2
238 exit 1
239fi
240
241POLDEK_INDEX_DIR="$($RPM --eval %_rpmdir)/"
242POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
243
244run_poldek() {
245 RES_FILE=$(tempfile)
246 if [ -n "$LOGFILE" ]; then
247 LOG=`eval echo $LOGFILE`
248 if [ -n "$LASTLOG_FILE" ]; then
249 echo "LASTLOG=$LOG" > $LASTLOG_FILE
250 fi
251 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
252 return $exit_pldk
253 else
254 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
255 return `cat ${RES_FILE}`
256 rm -rf ${RES_FILE}
257 fi
258}
259
260#---------------------------------------------
261# functions
262
263download_lftp() {
264 local outfile=$1 url=$2 retval tmpfile
265 # TODO: use mktemp
266 tmpfile=$outfile.tmp
267 lftp -c "
268 $([ "$DEBUG" = "yes" ] && echo "debug 5;")
269 set ssl:verify-certificate no;
270 set net:max-retries $WGET_RETRIES;
271 set http:user-agent \"$USER_AGENT\";
272 pget -n $PARALLEL_DOWNLOADS -c \"$url\" -o \"$tmpfile\"
273 "
274
275 retval=$?
276 if [ $retval -eq 0 ]; then
277 mv -f "$tmpfile" "$outfile"
278 else
279 rm -f "$tmpfile"
280 fi
281 return $retval
282}
283
284usage() {
285 if [ -n "$DEBUG" ]; then set -xv; fi
286 echo "\
287Usage: builder [--all-branches] [-D|--debug] [-V|--version] [--short-version] [-a|--add_cvs] [-b|-ba|--build]
288[-bb|--build-binary] [-bs|--build-source] [-bc] [-bi] [-bl] [-u|--try-upgrade]
289[{-cf|--cvs-force}] [{-B|--branch} <branch>] [--depth <number>]
290[-g|--get] [-h|--help] [--ftp] [--http] [{-l|--logtofile} <logfile>] [-m|--mr-proper]
291[-q|--quiet] [--date <yyyy-mm-dd> [-r <tag>] [{-T|--tag <tag>]
292[-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
293[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
294[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--short-circuit]
295[--show-bconds] [--with/--without <feature>] [--define <macro> <value>]
296<package>[.spec][:tag]
297
298-4 - force ipv4 when transferring files
299-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
300-6 - force ipv6 when transferring files
301-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
302--all-branches - make shallow fetch of all branches; --depth required
303-n5, --no-md5 - ignore md5 comments in spec
304-D, --debug - enable builder script debugging mode,
305-debug - produce rpm debug package (same as --opts -debug)
306-V, --version - output builder version string
307--short-version - output builder short version
308-a, --add_vcs - try add new package to PLD repo.
309-b, -ba, --build - get all files from PLD repo or HTTP/FTP and build package
310 from <package>.spec,
311-bb, --build-binary - get all files from PLD repo or HTTP/FTP and build binary
312 only package from <package>.spec,
313-bp, --build-prep - execute the %prep phase of <package>.spec,
314-bc - execute the %build phase of <package>.spec,
315-bi - execute the %install phase of <package>.spec
316-bl - execute the %files phase of <package>.spec
317-bs, --build-source - get all files from PLD repo or HTTP/FTP and only pack
318 them into src.rpm,
319--short-circuit - short-circuit build
320-B, --branch - add branch
321-c, --clean - clean all temporarily created files (in BUILD\$RPM_BUILD_ROOT) after rpmbuild commands.
322 may be used with building process.
323-m, --mr-proper - clean all temporarily created files (in BUILD, SOURCES,
324 SPECS and \$RPM_BUILD_ROOT). Doesn't run any rpm building.
325-cf, --cvs-force - use -f when tagging
326--define <macro> <value>
327 - define a macro <macro> with value <value>,
328--depth <number> - make shallow fetch
329--alt_kernel <kernel>
330 - same as --define 'alt_kernel <kernel>'
331--nodeps - rpm won't check any dependences
332-g, --get - get <package>.spec and all related files from PLD repo
333 or HTTP/FTP,
334-h, --help - this message,
335-jN, -j N - set %_smp_mflags to propagate concurrent jobs
336--ftp, --http - use ftp or http protocol to access distfiles server
337-l <logfile>, --logtofile <logfile>
338 - log all to file,
339-ncs, --no-cvs-specs
340 - don't pull from PLD repo
341-nd, --no-distfiles - don't download from distfiles
342-nm, --no-mirrors - don't download from mirror, if source URL is given,
343-nu, --no-urls - don't try to download from FTP/HTTP location,
344-ns, --no-srcs - don't download Sources/Patches
345-ns0, --no-source0 - don't download Source0
346-nn, --no-net - don't download anything from the net
347-pN, -p N - set PARALLEL_DOWNLOADS to N (default $PARALLEL_DOWNLOADS)
348-pm, --prefer-mirrors
349 - prefer mirrors (if any) over distfiles for SOURCES
350--no-init - don't initialize builder paths (SPECS and SOURCES)
351-ske,
352--skip-existing-files
353 - skip existing files in get_files
354--opts <rpm opts> - additional options for rpm
355-q, --quiet - be quiet,
356--date yyyy-mm-dd - build package using resources from specified date,
357-r <tag>, --cvstag <ref>
358 - build package using resources from specified branch/tag,
359-A - build package using master branch as any sticky tags/branch/date being reset.
360-R, --fetch-build-requires
361 - fetch what is BuildRequired,
362-RB, --remove-build-requires
363 - remove all you fetched with -R or --fetch-build-requires
364 remember, this option requires confirmation,
365-FRB, --force-remove-build-requires
366 - remove all you fetched with -R or --fetch-build-requires
367 remember, this option works without confirmation,
368-sd, --source-distfiles
369 - list sources available from distfiles (intended for offline
370 operations; does not work when Icon field is present
371 but icon file is absent),
372-sc, --source-cvs - list sources available from PLD repo
373-sdp, --source-distfiles-paths
374 - list sources available from distfiles -
375 paths relative to distfiles directory (intended for offline
376 operations; does not work when Icon field is present
377 but icon file is absent),
378-sf, --source-files - list sources - bare filenames (intended for offline
379 operations; does not work when Icon field is present
380 but icon file is absent),
381-lsp, --source-paths
382 - list sources - filenames with full local paths (intended for
383 offline operations; does not work when Icon field is present
384 but icon file is absent),
385-su, --source-urls - list urls - urls to sources and patches
386 intended for copying urls with spec with lots of macros in urls
387-T <tag> , --tag <tag>
388 - add git tag <tag> for files,
389-Tvs, --tag-version-stable
390 - add git tags STABLE and NAME-VERSION-RELEASE for files,
391-Ts, --tag-stable
392 - add git tag STABLE for files,
393-Tv, --tag-version
394 - add git tag NAME-VERSION-RELEASE for files,
395-Tp, --tag-prefix <prefix>
396 - add <prefix> to NAME-VERSION-RELEASE tags,
397-tt, --test-tag <prefix>
398 - fail if tag is already present,
399-ir, --integer-release-only
400 - allow only integer and snapshot releases
401-v, --verbose - be verbose,
402-u, --try-upgrade - check version, and try to upgrade package
403-un, --try-upgrade-with-float-version
404 - as above, but allow float version
405 php-pear-Services_Digg/
406--upgrade-version - upgrade to specified version in try-upgrade
407-U, --update - refetch sources, don't use distfiles, and update md5 comments
408-Upi, --update-poldek-indexes
409 - refresh or make poldek package index files.
410-sp, --skip-patch <patchnumber>
411 - don't apply <patchnumber>. may be repeated.
412-np, --nopatch <patchnumber>
413 - abort instead of applying patch <patchnumber>
414--show-bconds - show available conditional builds, which can be used
415 - with --with and/or --without switches.
416--show-bcond-args - show active bconds, from ~/.bcondrc. this is used by ./repackage.sh script.
417 In other words, the output is parseable by scripts.
418--show-avail-bconds - show available bconds
419--with/--without <feature>
420 - conditional build package depending on %_with_<feature>/
421 %_without_<feature> macro switch. You may now use
422 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
423 constructions. Set GROUP_BCONDS to yes to make use of it.
424--target <platform>, --target=<platform>
425 - build for platform <platform>.
426--init-rpm-dir - initialize ~/rpm directory structure
427"
428}
429
430# create tempfile. as secure as possible
431tempfile() {
432 mktemp --tmpdir -t builder.$PACKAGE_NAME.XXXXXX || ${TMPDIR:-/tmp}/builder.$RANDOM.$$
433}
434
435tempdir() {
436 mktemp --tmpdir -d builder.$PACKAGE_NAME.XXXXXX
437}
438
439# inserts git log instead of %changelog
440# outputs name of modified file created by tempfile
441insert_gitlog() {
442 local SPECFILE=$1 specdir=$(tempdir) gitlog=$(tempfile) speclog=$(tempfile)
443
444 # allow this being customized
445 local log_entries=$(rpm -E '%{?_buildchangelogtruncate}')
446
447 # rpm5.org/rpm.org do not parse any other date format than 'Wed Jan 1 1997'
448 # otherwise i'd use --date=iso here
449 # http://rpm5.org/cvs/fileview?f=rpm/build/parseChangelog.c&v=2.44.2.1
450 # http://rpm.org/gitweb?p=rpm.git;a=blob;f=build/parseChangelog.c#l31
451 # NOTE: changelog date is always in UTC for rpmbuild
452 # * 1265749244 +0000 Random Hacker <nikt@pld-linux.org> 9370900
453 git rev-list --date-order -${log_entries:-20} HEAD | while read sha1; do
454 local logfmt='%B%n'
455 git notes list $sha1 > /dev/null 2>&1 && logfmt=%N
456 git log -n 1 $sha1 --format=format:"* %ad %an <%ae> %h%n${logfmt}%n" --date=raw | sed '/^$/q'
457 done > $gitlog
458 LC_ALL=C gawk '/^\* /{printf("* %s %s\n", strftime("%a %b %d %Y", $2), substr($0, length($1)+length($2)+length($3)+4)); next}{print}' $gitlog > $speclog
459 sed '/^%changelog/,$d' $SPECFILE | sed -e "\${
460 a%changelog
461 r $speclog
462 }
463 " > $specdir/$SPECFILE
464 rm -f $gitlog $speclog
465 echo $specdir
466}
467
468# change dependency to specname
469# common changes:
470# - perl(Package::Name) -> perl-Package-Name
471depspecname() {
472 local package="$1"
473
474 package=$(echo "$package" | sed -e '/perl(.*)/{s,perl(\(.*\)),perl-\1,;s,::,-,g};' -e 's/-\(devel\|static\)$//' )
475 echo "$package"
476}
477
478update_shell_title() {
479 [ -t 1 ] || return
480 local len=${COLUMNS:-80}
481 local msg="$(echo "$*" | cut -c-$len)"
482
483 if [ -n "$BE_VERBOSE" ]; then
484 echo >&2 "$(date +%s.%N) $*"
485 fi
486
487 if [ "x$TITLECHANGE" = "xyes" -o "x$TITLECHANGE" = "x" ]; then
488 local pkg
489 if [ -n "$PACKAGE_NAME" ]; then
490 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
491 else
492 pkg=${SPECFILE}
493 fi
494
495 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
496 msg=$(echo $msg | tr -d '\n\r')
497 case "$TERM" in
498 cygwin|xterm*)
499 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
500 ;;
501 screen*)
502 echo >&2 -ne "\033]0;$msg\007"
503 ;;
504 esac
505 fi
506}
507
508# set TARGET from BuildArch: from SPECFILE
509set_spec_target() {
510 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
511 tmp=$(awk '/^BuildArch:/ { print $NF; exit }' $ASSUMED_NAME/$SPECFILE)
512 if [ "$tmp" ]; then
513 target_platform=$(rpm -E '%{_target_vendor}-%{_target_os}%{?_gnu}')
514 TARGET="$tmp"
515 case "$RPMBUILD" in
516 "rpmbuild")
517 TARGET_SWITCH="--target ${TARGET}-${target_platform}" ;;
518 "rpm")
519 TARGET_SWITCH="--target=$TARGET" ;;
520 esac
521 fi
522 fi
523}
524
525# runs rpm with minimal macroset
526minirpm() {
527 # we reset macros not to contain macros.build as all the %() macros are
528 # executed here, while none of them are actually needed.
529 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
530 safe_macrofiles=$(rpm $TARGET_SWITCH --showrc | awk -F: '/^macrofiles/ { gsub(/^macrofiles[ \t]+:/, "", $0); gsub(/:.*macros.build:/, ":", $0); print $0 } ')
531
532 # TODO: move these to /usr/lib/rpm/macros
533 cat > $BUILDER_MACROS <<'EOF'
534%x8664 x86_64 amd64 ia32e
535%alt_kernel %{nil}
536%_alt_kernel %{nil}
537%bootstrap_release() %{1}
538%requires_releq_kernel_up(s:n:) %{nil}
539%requires_releq_kernel_smp(s:n:) %{nil}
540%requires_releq_kernel(s:n:) %{nil}
541%requires_releq() %{nil}
542%pyrequires_eq() %{nil}
543%requires_eq() %{nil}
544%requires_eq_to() %{nil}
545%requires_ge() %{nil}
546%requires_ge_to() %{nil}
547%requires_ge() %{nil}
548%releq_kernel_up(n:) ERROR
549%releq_kernel_smp(n:) ERROR
550%releq_kernel(n:) ERROR
551%kgcc_package ERROR
552%_fontsdir ERROR
553%ruby_version ERROR
554%ruby_ver_requires_eq() %{nil}
555%ruby_mod_ver_requires_eq() %{nil}
556%__php_api_requires() %{nil}
557%php_major_version ERROR
558%php_api_version ERROR
559%requires_xorg_xserver_extension %{nil}
560%requires_xorg_xserver_xinput %{nil}
561%requires_xorg_xserver_font %{nil}
562%requires_xorg_xserver_videodrv %{nil}
563%py_ver ERROR
564%perl_vendorarch ERROR
565%perl_vendorlib ERROR
566# damn. need it here! - copied from /usr/lib/rpm/macros.build
567%tmpdir %(echo "${TMPDIR:-/tmp}")
568%patchset_source(f:b:) %(
569 base=%{-b*}%{!-b*:10000};
570 start=$(expr $base + %1);
571 end=$(expr $base + %{?2}%{!?2:%{1}});
572 # we need to call seq twice as it doesn't allow two formats
573 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
574 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
575 paste %{tmpdir}/__ps{1,2};
576 rm -f %{tmpdir}/__ps{1,2};
577) \
578%{nil}
579%add_etc_shells(p) %{p:<lua>}
580%remove_etc_shells(p) %{p:<lua>}
581%lua_add_etc_shells() %{nil}
582%lua_remove_etc_shells() %{nil}
583%required_jdk %{nil}
584%buildrequires_jdk %{nil}
585%pear_package_print_optionalpackages %{nil}
586EOF
587 if [ "$NOINIT" = "yes" ] ; then
588 cat >> $BUILDER_MACROS <<'EOF'
589%_specdir ./
590%_sourcedir ./
591EOF
592 fi
593 eval $RPMBUILD $TARGET_SWITCH --macros "$safe_macrofiles:$BUILDER_MACROS" $QUIET $RPMOPTS $RPMBUILDOPTS $BCOND $* 2>&1
594}
595
596cache_rpm_dump() {
597 if [ -n "$DEBUG" ]; then
598 set -x
599 set -v
600 fi
601
602 if [ -x /usr/bin/rpm-specdump ]; then
603 update_shell_title "cache_rpm_dump using rpm-specdump command"
604 rpm_dump_cache=$(rpm-specdump $TARGET_SWITCH $BCOND $SPECFILE)
605 else
606 update_shell_title "cache_rpm_dump using rpmbuild command"
607 local rpm_dump
608 rpm_dump=`
609 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
610 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
611 case "$RPMBUILD" in
612 rpm)
613 ARGS='-bp'
614 ;;
615 rpmbuild)
616 ARGS='--nodigest --nosignature --nobuild'
617 ;;
618 esac
619 minirpm $ARGS --define "'prep $dump'" --nodeps $SPECFILE
620 `
621 if [ $? -gt 0 ]; then
622 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
623 echo "$error" >&2
624 Exit_error err_build_fail
625 fi
626
627 # make small dump cache
628 rpm_dump_cache=`echo "$rpm_dump" | awk '
629 $2 ~ /^SOURCEURL/ {print}
630 $2 ~ /^PATCHURL/ {print}
631 $2 ~ /^nosource/ {print}
632 $2 ~ /^PACKAGE_/ {print}
633 '`
634 fi
635
636 update_shell_title "cache_rpm_dump: OK!"
637}
638
639rpm_dump() {
640 if [ -z "$rpm_dump_cache" ] ; then
641 echo >&2 "internal error: cache_rpm_dump not called! (missing %prep?)"
642 fi
643 echo "$rpm_dump_cache"
644}
645
646get_icons() {
647 update_shell_title "get icons"
648 ICONS=$(awk '/^Icon:/ {print $2}' $PACKAGE_DIR/${SPECFILE})
649 if [ -z "$ICONS" ]; then
650 return
651 fi
652
653 rpm_dump_cache="kalasaba" NODIST="yes" get_files $ICONS
654}
655
656parse_spec() {
657 update_shell_title "parsing specfile"
658 if [ -n "$DEBUG" ]; then
659 set -x
660 set -v
661 fi
662
663 # icons are needed for successful spec parse
664 get_icons
665
666 cd $PACKAGE_DIR
667 cache_rpm_dump
668
669 if rpm_dump | grep -qEi ":.*nosource.*1"; then
670 FAIL_IF_NO_SOURCES="no"
671 fi
672
673 if [ "$NOSRCS" != "yes" ]; then
674 SOURCES=$(rpm_dump | awk '$2 ~ /^SOURCEURL[0-9]+/ {print substr($2, length("SOURCEURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
675 PATCHES=$(rpm_dump | awk '$2 ~ /^PATCHURL[0-9]+/ {print substr($2, length("PATCHURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
676 ICONS=$(awk '/^Icon:/ {print $2}' ${SPECFILE})
677 fi
678
679 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3; exit}')
680 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3; exit}')
681 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3; exit}')
682
683 if [ "$PACKAGE_NAME" != "$ASSUMED_NAME" ]; then
684 echo >&2 "WARNING! Spec name ($ASSUMED_NAME) does not agree with package name ($PACKAGE_NAME)"
685 fi
686
687 if [ -n "$BE_VERBOSE" ]; then
688 echo "- Sources : `nourl $SOURCES`"
689 if [ -n "$PATCHES" ]; then
690 echo "- Patches : `nourl $PATCHES`"
691 else
692 echo "- Patches : *no patches needed*"
693 fi
694 if [ -n "$ICONS" ]; then
695 echo "- Icon : `nourl $ICONS`"
696 else
697 echo "- Icon : *no package icon*"
698 fi
699 echo "- Name : $PACKAGE_NAME"
700 echo "- Version : $PACKAGE_VERSION"
701 echo "- Release : $PACKAGE_RELEASE"
702 fi
703
704 update_shell_title "parse_spec: OK!"
705}
706
707Exit_error() {
708 if [ -n "$DEBUG" ]; then
709 set -x
710 set -v
711 fi
712
713 cd "$__PWD"
714
715 case "$1" in
716 "err_no_spec_in_cmdl" )
717 remove_build_requires
718 echo >&2 "ERROR: spec file name not specified."
719 exit 2 ;;
720 "err_invalid_cmdline" )
721 echo >&2 "ERROR: invalid command line arg ($2)."
722 exit 2 ;;
723 "err_no_spec_in_repo" )
724 remove_build_requires
725 echo >&2 "Error: spec file not stored in PLD repo."
726 exit 3 ;;
727 "err_no_source_in_repo" )
728 remove_build_requires
729 echo >&2 "Error: some source, patch or icon files not stored in PLD repo. ($2)"
730 exit 4 ;;
731 "err_cvs_add_failed" )
732 echo >&2 "Error: failed to add package to PLD repo."
733 exit 4 ;;
734 "err_build_fail" )
735 remove_build_requires
736 echo >&2 "Error: package build failed. (${2:-no more info})"
737 exit 5 ;;
738 "err_no_package_data" )
739 remove_build_requires
740 echo >&2 "Error: couldn't get out package name/version/release from spec file."
741 exit 6 ;;
742 "err_tag_exists" )
743 remove_build_requires
744 echo >&2 "Tag ${2} already exists"
745 exit 9 ;;
746 "err_fract_rel" )
747 remove_build_requires
748 echo >&2 "Release ${2} not integer and not a snapshot."
749 exit 10 ;;
750 "err_branch_exists" )
751 remove_build_requires
752 echo >&2 "Tree branch already exists (${2})."
753 exit 11 ;;
754 "err_acl_deny" )
755 remove_build_requires
756 echo >&2 "Error: conditions reject building this spec (${2})."
757 exit 12 ;;
758 "err_remote_problem" )
759 remove_build_requires
760 echo >&2 "Error: problem with remote (${2})"
761 exit 13 ;;
762 "err_not_implemented" )
763 remove_build_requires
764 echo >&2 "Error: functionality not yet imlemented"
765 exit 110 ;;
766 esac
767 echo >&2 "Unknown error."
768 exit 100
769}
770
771init_builder() {
772 if [ -n "$DEBUG" ]; then
773 set -x
774 set -v
775 fi
776
777 if [ "$NOINIT" != "yes" ] ; then
778 TOP_DIR=$(eval $RPM $RPMOPTS --eval '%{_topdir}')
779
780 local macros_ver=$(rpm -E %?rpm_build_macros)
781 if [ -z "$macros_ver" ]; then
782 REPO_DIR=$TOP_DIR/packages
783 PACKAGE_DIR=$TOP_DIR/packages/$ASSUMED_NAME
784 else
785 if awk "BEGIN{exit($macros_ver>=$RPM_MACROS_VER)}"; then
786 echo >&2 "builder requires rpm-build-macros >= $RPM_MACROS_VER"
787 exit 1
788 fi
789 REPO_DIR=$TOP_DIR
790 PACKAGE_DIR=$REPO_DIR/$ASSUMED_NAME
791 fi
792 else
793 REPO_DIR="."
794 PACKAGE_DIR="."
795 fi
796 export GIT_WORK_TREE=$PACKAGE_DIR
797 export GIT_DIR=$PACKAGE_DIR/.git
798
799 if [ -d "$GIT_DIR" ] && [ -z "$CVSTAG" ]; then
800 if CVSTAG=$(GIT_DIR=$GIT_DIR git symbolic-ref HEAD) 2>/dev/null; then
801 CVSTAG=${CVSTAG#refs/heads/}
802 if [ "$CVSTAG" != "master" ]; then
803 echo >&2 "builder: Active branch $CVSTAG. Use -r BRANCHNAME to override"
804 fi
805 else
806 echo >&2 "On detached HEAD. Use -r BRANCHNAME to override"
807 HEAD_DETACHED="yes"
808 fi
809 elif [ "$CVSTAG" = "HEAD" ]; then
810 # assume -r HEAD is same as -A
811 CVSTAG="master"
812 fi
813
814 __PWD=$(pwd)
815}
816
817create_git_repo() {
818 update_shell_title "add_package"
819
820 if [ -n "$DEBUG" ]; then
821 set -x
822 set -v
823 fi
824
825 cd "$REPO_DIR"
826 SPECFILE=$(basename $SPECFILE)
827 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
828 echo "ERROR: No package to add ($ASSUMED_NAME/$SPECFILE)" >&2
829 exit 101
830 fi
831 [ -d "$ASSUMED_NAME/.git" ] || NEW_REPO=yes
832 ssh $GIT_PUSH create ${ASSUMED_NAME} || Exit_error err_cvs_add_failed
833 git init
834 git remote add $REMOTE_PLD ${GIT_SERVER}/${PACKAGES_DIR}/${ASSUMED_NAME}.git && \
835 git remote set-url --push $REMOTE_PLD ssh://${GIT_PUSH}/${PACKAGES_DIR}/${ASSUMED_NAME} \
836 || Exit_error err_remote_problem $REMOTE_PLD
837}
838
839get_spec() {
840
841 update_shell_title "get_spec"
842
843 if [ -n "$DEBUG" ]; then
844 set -x
845 set -v
846 fi
847
848 cd "$REPO_DIR"
849 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
850 # XXX: still needed?
851 SPECFILE=$(basename $SPECFILE)
852 fi
853
854 if [ "$NOCVSSPEC" != "yes" ]; then
855 if [ -z "$DEPTH" ]; then
856 if [ -d "$ASSUMED_NAME/.git" ]; then
857 git fetch $REMOTE_PLD || Exit_error err_no_spec_in_repo
858 elif [ "$ADD_PACKAGE_CVS" = "yes" ]; then
859 if [ ! -r "$ASSUMED_NAME/$SPECFILE" ]; then
860 echo "ERROR: No package to add ($ASSUMED_NAME/$SPECFILE)" >&2
861 exit 101
862 fi
863 Exit_error err_not_implemented
864 else
865 (
866 unset GIT_WORK_TREE
867 git clone -o $REMOTE_PLD ${GIT_SERVER}/${PACKAGES_DIR}/${ASSUMED_NAME}.git || {
868 # softfail if new package, i.e not yet added to PLD rep
869 [ ! -f "$ASSUMED_NAME/$SPECFILE" ] && Exit_error err_no_spec_in_repo
870 echo "Warning: package not in CVS - assuming new package"
871 NOCVSSPEC="yes"
872 }
873 git config --local --add "remote.$REMOTE_PLD.fetch" 'refs/notes/*:refs/notes/*'
874 git remote set-url --push $REMOTE_PLD ssh://${GIT_PUSH}/${PACKAGES_DIR}/${ASSUMED_NAME}
875 )
876 fi
877 else
878 if [ ! -d "$ASSUMED_NAME/.git" ]; then
879 if [ ! -d "$ASSUMED_NAME" ]; then
880 mkdir $ASSUMED_NAME
881 fi
882 git init
883 git remote add $REMOTE_PLD ${GIT_SERVER}/${PACKAGES_DIR}/${ASSUMED_NAME}.git
884 git config --local --add "remote.$REMOTE_PLD.fetch" 'refs/notes/*:refs/notes/*'
885 git remote set-url --push $REMOTE_PLD ssh://${GIT_PUSH}/${PACKAGES_DIR}/${ASSUMED_NAME}
886 CVSTAG=${CVSTAG:-"master"}
887 fi
888 local refs=''
889 if [ -z "$ALL_BRANCHES" ]; then
890 refs="${CVSTAG}:remotes/${REMOTE_PLD}/${CVSTAG}"
891 fi
892 git fetch $DEPTH $REMOTE_PLD $refs || {
893 echo >&2 "Error: branch $CVSTAG does not exist"
894 exit 3
895 }
896 fi
897 git fetch $REMOTE_PLD 'refs/notes/*:refs/notes/*'
898
899 cvsignore_df .gitignore
900
901 # add default log format to .gitignore if it is relative to package dir
902 if [ -n "$LOGFILE" -a "$LOGFILE" = "${LOGFILE##*/}" ]; then
903 # substitute known "macros" to glob
904 local logfile=$(echo "$LOGFILE" | sed -e 's,\$\(PACKAGE_NAME\|DATE\),*,g')
905 if [ "$logfile" ]; then
906 cvsignore_df "$logfile"
907 fi
908 fi
909
910 # create symlinks for tools
911 if [ "$SYMLINK_TOOLS" != "no" ]; then
912 for a in dropin md5 adapter builder {relup,compile,repackage,rsync,pearize}.sh pldnotify.awk; do
913 # skip tools that don't exist in top dir
914 [ -f $a ] || continue
915 # skip tools that already exist
916 [ -f $ASSUMED_NAME/$a ] && continue
917 ln -s ../$a $ASSUMED_NAME
918 cvsignore_df $a
919 done
920 fi
921 fi
922
923 if [ -n "$CVSTAG" ]; then
924 git checkout "$CVSTAG" -- 2>/dev/null || git checkout -t "${REMOTE_PLD}/$CVSTAG" > /dev/null || exit
925 git symbolic-ref -q HEAD > /dev/null &&
926 git merge '@{u}'
927 if [ -n "$CVSDATE" ]; then
928 git checkout $(git rev-list -n1 --before="'$CVSDATE'" $CVSTAG) || exit 1
929 fi
930 fi
931
932 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
933 Exit_error err_no_spec_in_repo
934 fi
935
936 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
937 chmod $CHMOD_MODE $ASSUMED_NAME/$SPECFILE
938 fi
939 unset OPTIONS
940 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $ASSUMED_NAME/$SPECFILE
941
942 set_spec_target
943}
944
945find_mirror() {
946 cd "$REPO_DIR"
947 local url="$1"
948 if [ ! -f "mirrors" ] ; then
949 ln -s rpm-build-tools/mirrors .
950 fi
951
952 IFS="|"
953 local origin mirror name rest ol prefix
954 while read origin mirror name rest; do
955 # skip comments and empty lines
956 if [ -z "$origin" ] || [ "${origin#\#}" != "$origin" ]; then
957 continue
958 fi
959 ol=$(echo -n "$origin" | wc -c)
960 prefix=$(echo -n "$url" | head -c $ol)
961 if [ "$prefix" = "$origin" ] ; then
962 suffix=$(echo "$url" | cut -b $((ol+1))-)
963 echo -n "$mirror$suffix"
964 return 0
965 fi
966 done < mirrors
967 echo "$url"
968}
969
970# Warning: unpredictable results if same URL used twice
971src_no() {
972 local file="$1"
973 # escape some regexp characters if part of file name
974 file=$(echo "$file" | sed -e 's#\([\+\*\.\&\#\?]\)#\\\1#g')
975 cd $PACKAGE_DIR
976 rpm_dump | \
977 grep -E "(SOURCE|PATCH)URL[0-9]*[ ]*${file}""[ ]*$" | \
978 sed -e 's/.*\(SOURCE\|PATCH\)URL\([0-9][0-9]*\).*/\1\2/' | \
979 head -n 1 | tr OURCEATH ourceath | xargs
980}
981
982src_md5() {
983 [ "$NO5" = "yes" ] && return
984 no=$(src_no "$1")
985 [ -z "$no" ] && return
986 cd $PACKAGE_DIR
987 local md5
988
989 if [ -f additional-md5sums ]; then
990 md5=$(grep -s -v '^#' additional-md5sums | \
991 grep -E "[ ]$(basename "$1")([ ,]|\$)" | \
992 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
993 grep -E '^[0-9a-f]{32}$')
994
995 if [ "$md5" ]; then
996 if [ $(echo "$md5" | wc -l) != 1 ] ; then
997 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
998 fi
999 echo "$md5" | tail -n 1
1000 return
1001 fi
1002 fi
1003
1004 source_md5=$(grep -iE "^#[ ]*(No)?$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://')
1005 if [ -n "$source_md5" ]; then
1006 echo $source_md5
1007 else
1008 source_md5=`grep -i "BuildRequires:[ ]*digest(%SOURCE$no)[ ]*=" $SPECFILE | sed -e 's/.*=//'`
1009 if [ -n "$source_md5" ]; then
1010 echo $source_md5
1011 else
1012 # we have empty SourceX-md5, but it is still possible
1013 # that we have NoSourceX-md5 AND NoSource: X
1014 nosource_md5=`grep -i "^#[ ]*No$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
1015 if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" ] ; then
1016 echo $nosource_md5
1017 fi
1018 fi
1019 fi
1020}
1021
1022distfiles_path() {
1023 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
1024}
1025
1026distfiles_url() {
1027 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
1028}
1029
1030distfiles_attic_url() {
1031 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
1032}
1033
1034good_md5() {
1035 md5=$(src_md5 "$1")
1036 [ "$md5" = "" ] || \
1037 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
1038}
1039
1040good_size() {
1041 size=$(find $(nourl "$1") -printf "%s" 2>/dev/null)
1042 [ -n "$size" -a "$size" -gt 0 ]
1043}
1044
1045cvsignore_df() {
1046 if [ "$CVSIGNORE_DF" != "yes" ]; then
1047 return
1048 fi
1049 cvsignore=${PACKAGE_DIR}/.gitignore
1050
1051 # add only if not yet there
1052 if ! awk -vf="$1" -vc=1 '$0 == f { c = 0 } END { exit c }' $cvsignore 2>/dev/null; then
1053 echo "$1" >> $cvsignore
1054 fi
1055}
1056
1057# returns true if "$1" is ftp, http or https protocol url
1058is_url() {
1059 case "$1" in
1060 ftp://*|http://*|https://*)
1061 return 0
1062 ;;
1063 esac
1064 return 1
1065}
1066
1067update_md5() {
1068 if [ $# -eq 0 ]; then
1069 return
1070 fi
1071
1072 update_shell_title "update md5"
1073 if [ -n "$DEBUG" ]; then
1074 set -x
1075 set -v
1076 fi
1077
1078 cd "$PACKAGE_DIR"
1079
1080 # pass 1: check files to be fetched
1081 local todo
1082 local need_files
1083 for i in "$@"; do
1084 local fp=$(nourl "$i")
1085 local srcno=$(src_no "$i")
1086 if [ -n "$ADD5" ]; then
1087 [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
1088 grep -qiE '^#[ ]*'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE && continue
1089 grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE && continue
1090 else
1091 grep -qiE '^#[ ]*'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE || grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE || continue
1092 fi
1093 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
1094 need_files="$need_files $i"
1095 fi
1096 done
1097
1098 # pass 1a: get needed files
1099 if [ "$need_files" ]; then
1100 get_files $need_files
1101 fi
1102
1103 # pass 2: proceed with md5 adding or updating
1104 for i in "$@"; do
1105 local fp=$(nourl "$i")
1106 local srcno=$(src_no "$i")
1107 local md5=$(grep -iE '^#[ ]*(No)?'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE )
1108 if [ -z "$md5" ]; then
1109 md5=$(grep -iE '^[ ]*BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE )
1110 fi
1111 if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
1112 local tag="# $srcno-md5:\t"
1113 if [[ "$md5" == *NoSource* ]]; then
1114 tag="# No$srcno-md5:\t"
1115 elif [ -n "$USEDIGEST" ]; then
1116 tag="BuildRequires:\tdigest(%SOURCE$srcno) = "
1117 fi
1118 md5=$(md5sum "$fp" | cut -f1 -d' ')
1119 echo "Updating $srcno ($md5: $fp)."
1120 perl -i -ne '
1121 print unless (/^\s*#\s*(No)?'$srcno'-md5\s*:/i or /^\s*BuildRequires:\s*digest\(%SOURCE'$srcno'\)/i);
1122 print "'"$tag$md5"'\n" if /^'$srcno'\s*:\s+/i;
1123 ' \
1124 $PACKAGE_DIR/$SPECFILE
1125 fi
1126 done
1127}
1128
1129check_md5() {
1130 local bad
1131 [ "$NO5" = "yes" ] && return
1132
1133 update_shell_title "check md5"
1134
1135 for i in "$@"; do
1136 bad=0
1137 if ! good_md5 "$i"; then
1138 echo -n "MD5 sum mismatch."
1139 bad=1
1140 fi
1141 if ! good_size "$i"; then
1142 echo -n "0 sized file."
1143 bad=1
1144 fi
1145
1146 if [ $bad -eq 1 ]; then
1147 echo " Use -U to refetch sources,"
1148 echo "or -5 to update md5 sums, if you're sure files are correct."
1149 Exit_error err_no_source_in_repo $i
1150 fi
1151 done
1152}
1153
1154get_files() {
1155 update_shell_title "get_files"
1156
1157 if [ -n "$DEBUG" ]; then
1158 set -x
1159 set -v
1160 fi
1161
1162 if [ $# -gt 0 ]; then
1163 cd "$PACKAGE_DIR"
1164
1165 local nc=0
1166 local get_files_cvs=""
1167 for i in "$@"; do
1168 nc=$((nc + 1))
1169 local cvsup=0
1170 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
1171 update_shell_title "$i"
1172 local fp=`nourl "$i"`
1173 if [ "$SKIP_EXISTING_FILES" = "yes" ] && [ -f "$fp" ]; then
1174 continue
1175 fi
1176
1177 FROM_DISTFILES=0
1178 local srcmd5=$(src_md5 "$i")
1179
1180 # we know if source/patch is present in cvs/distfiles
1181 # - has md5 (in distfiles)
1182 # - in cvs... ideas?
1183
1184 # CHECK: local file didn't exist or always cvs up (first) requested.
1185 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
1186 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
1187 echo "Warning: no URL given for $i"
1188 fi
1189 target="$fp"
1190
1191 if [ -z "$NODIST" ] && [ -n "$srcmd5" ]; then
1192 if good_md5 "$i" && good_size "$i"; then
1193 echo "$fp having proper md5sum already exists"
1194 continue
1195 fi
1196
1197 # optionally prefer mirror over distfiles if there's mirror
1198 # TODO: build url list and then try each url from the list
1199 if [ -n "$PREFMIRRORS" ] && [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
1200 url="$im"
1201 else
1202 url=$(distfiles_url "$i")
1203 fi
1204
1205 url_attic=$(distfiles_attic_url "$i")
1206 FROM_DISTFILES=1
1207 # is $url local file?
1208 if [[ "$url" = [./]* ]]; then
1209 update_shell_title "${GETLOCAL%% *}: $url"
1210 ${GETLOCAL} $url $target
1211 else
1212 if [ -z "$NOMIRRORS" ]; then
1213 url=$(find_mirror "$url")
1214 fi
1215
1216 local uri=${url}
1217 # make shorter message for distfiles urls
1218 if [[ "$uri" = ${PROTOCOL}${DISTFILES_SERVER}* ]] || [[ "$uri" = ${PROTOCOL}${ATTICDISTFILES_SERVER}* ]]; then
1219 uri=${uri#${PROTOCOL}${DISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1220 uri=${uri#${PROTOCOL}${ATTICDISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1221 uri="df: $uri"
1222 fi
1223 update_shell_title "${GETURI%% *}: $uri"
1224 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
1225 if [ "`echo $url | grep -E 'ftp://'`" ]; then
1226 update_shell_title "${GETURI2%% *}: $url"
1227 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
1228 fi
1229 fi
1230
1231 # is it empty file?
1232 if [ ! -s "$target" ]; then
1233 rm -f "$target"
1234 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
1235 update_shell_title "${GETLOCAL%% *}: $url_attic"
1236 ${GETLOCAL} $url_attic $target
1237 else
1238 if [ -z "$NOMIRRORS" ]; then
1239 url_attic=$(find_mirror "$url_attic")
1240 fi
1241 update_shell_title "${GETURI%% *}: $url_attic"
1242 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
1243 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
1244 update_shell_title "${GETURI2%% *}: $url_attic"
1245 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
1246 fi
1247 test -s "$target" || rm -f "$target"
1248 fi
1249 fi
1250
1251 if [ -s "$target" ]; then
1252 cvsignore_df $target
1253 else
1254 rm -f "$target"
1255 FROM_DISTFILES=0
1256 fi
1257 fi
1258
1259 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
1260 if [ -z "$NOMIRRORS" ]; then
1261 im=$(find_mirror "$i")
1262 else
1263 im="$i"
1264 fi
1265 update_shell_title "${GETURI%% *}: $im"
1266 ${GETURI} ${OUTFILEOPT} "$target" "$im" || \
1267 if [ "`echo $im | grep -E 'ftp://'`" ]; then
1268 update_shell_title "${GETURI2%% *}: $im"
1269 ${GETURI2} ${OUTFILEOPT} "$target" "$im"
1270 fi
1271 test -s "$target" || rm -f "$target"
1272 fi
1273
1274 if [ "$cvsup" = 1 ]; then
1275 continue
1276 fi
1277
1278 fi
1279
1280 # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
1281 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
1282 Exit_error err_no_source_in_repo $i
1283 fi
1284
1285 # we check md5 here just only to refetch immediately
1286 if good_md5 "$i" && good_size "$i"; then
1287 :
1288 elif [ "$FROM_DISTFILES" = 1 ]; then
1289 # wrong md5 from distfiles: remove the file and try again
1290 # but only once ...
1291 echo "MD5 sum mismatch. Trying full fetch."
1292 FROM_DISTFILES=2
1293 rm -f $target
1294 update_shell_title "${GETURI%% *}: $url"
1295 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
1296 if [ "`echo $url | grep -E 'ftp://'`" ]; then
1297 update_shell_title "${GETURI2%% *}: $url"
1298 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
1299 fi
1300 if [ ! -s "$target" ]; then
1301 rm -f "$target"
1302 update_shell_title "${GETURI%% *}: $url_attic"
1303 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
1304 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
1305 update_shell_title "${GETURI2%% *}: $url_attic"
1306 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
1307 fi
1308 fi
1309 test -s "$target" || rm -f "$target"
1310 fi
1311 done
1312 SHELL_TITLE_PREFIX=""
1313
1314
1315 if [ "$CHMOD" = "yes" ]; then
1316 CHMOD_FILES=$(nourl "$@")
1317 if [ -n "$CHMOD_FILES" ]; then
1318 chmod $CHMOD_MODE $CHMOD_FILES
1319 fi
1320 fi
1321 fi
1322}
1323
1324tag_exist() {
1325# If tag exists and points to other commit exit with error
1326# If it existsts and points to HEAD return 1
1327# If it doesn't exist return 0
1328 local _tag="$1"
1329 local sha1=$(git rev-parse HEAD)
1330 echo "Searching for tag $_tag..."
1331 if [ -n "$DEPTH" ]; then
1332 local ref=$(git ls-remote $REMOTE_PLD "refs/tags/$_tag" | cut -c -40)
1333 else
1334 local ref=$(git show-ref -s "refs/tags/$_tag")
1335 fi
1336 [ -z "$ref" ] && return 0
1337 [ "$ref" = "$sha1" ] || Exit_error err_tag_exists "$_tag"
1338 return 1
1339}
1340
1341make_tagver() {
1342 if [ -n "$DEBUG" ]; then
1343 set -x
1344 set -v
1345 fi
1346
1347 # Check whether first character of PACKAGE_NAME is legal for tag name
1348 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
1349 TAG_PREFIX=tag_
1350 fi
1351
1352 # NOTE: CVS tags may must not contain the characters `$,.:;@'
1353 TAGVER=$(echo $TAG_PREFIX$PACKAGE_NAME-$PACKAGE_VERSION-$PACKAGE_RELEASE)
1354
1355 # Remove @kernel.version_release from TAGVER because tagging sources
1356 # could occur with different kernel-headers than kernel-headers used at build time.
1357 # besides, %{_kernel_ver_str} is not expanded.
1358
1359 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1@%{_kernel_ver_str}
1360 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1
1361
1362 TAGVER=${TAGVER%@*}
1363 echo -n "$TAGVER"
1364}
1365
1366tag_files() {
1367 if [ -n "$DEBUG" ]; then
1368 set -x
1369 set -v
1370 fi
1371
1372 echo "Version: $PACKAGE_VERSION"
1373 echo "Release: $PACKAGE_RELEASE"
1374
1375 local _tag
1376 if [ "$TAG_VERSION" = "yes" ]; then
1377 _tag=`make_tagver`
1378 fi
1379 if [ -n "$TAG" ]; then
1380 _tag="$TAG"
1381 fi
1382 echo "tag: $_tag"
1383
1384 local OPTIONS="tag $CVS_FORCE"
1385
1386 cd "$PACKAGE_DIR"
1387
1388 if tag_exist $_tag || [ -n "$CVS_FORCE" ]; then
1389 update_shell_title "tag sources: $_tag"
1390 git $OPTIONS $_tag || exit
1391 git push $CVS_FORCE $REMOTE_PLD tag $_tag || Exit_error err_remote_problem $REMOTE_PLD
1392 else
1393 echo "Tag $_tag already exists and points to the same commit"
1394 fi
1395}
1396
1397branch_files() {
1398 TAG=$1
1399 echo "Git branch: $TAG"
1400 shift
1401
1402 if [ -n "$DEBUG" ]; then
1403 set -x
1404 set -v
1405 fi
1406
1407 local OPTIONS="branch $CVS_FORCE"
1408
1409 cd "$PACKAGE_DIR"
1410 git $OPTIONS $TAG || exit
1411}
1412
1413
1414# this function should exit early if package can't be built for this arch
1415# this avoids unneccessary BR filling.
1416check_buildarch() {
1417 local out ret
1418 out=$(minirpm --short-circuit -bp --define "'prep exit 0'" --nodeps $SPECFILE 2>&1)
1419 ret=$?
1420 if [ $ret -ne 0 ]; then
1421 echo >&2 "$out"
1422 exit $ret
1423 fi
1424}
1425
1426# from relup.sh
1427set_release() {
1428 local specfile="$1"
1429 local rel="$2"
1430 local newrel="$3"
1431 sed -i -e "
1432 s/^\(%define[ \t]\+_\?rel[ \t]\+\)$rel\$/\1$newrel/
1433 s/^\(Release:[ \t]\+\)$rel\$/\1$newrel/
1434 " $specfile
1435}
1436
1437set_version() {
1438 local specfile="$1"
1439 local ver="$2" subver=$ver
1440 local newver="$3" newsubver=$newver
1441
1442 # try handling subver, everything that's not numeric-dotted in version
1443 if grep -Eq '%define\s+subver' $specfile; then
1444 subver=$(echo "$ver" | sed -re 's,^[0-9.]+,,')
1445 ver=${ver%$subver}
1446 newsubver=$(echo "$newver" | sed -re 's,^[0-9.]+,,')
1447 newver=${newver%$newsubver}
1448 fi
1449 sed -i -e "
1450 s/^\(%define[ \t]\+_\?ver[ \t]\+\)$ver\$/\1$newver/
1451 s/^\(%define[ \t]\+subver[ \t]\+\)$subver\$/\1$newsubver/
1452 s/^\(Version:[ \t]\+\)$ver\$/\1$newver/
1453 " $specfile
1454}
1455
1456try_upgrade() {
1457 if [ -n "$TRY_UPGRADE" ]; then
1458 local TNOTIFY TNEWVER TOLDVER
1459 update_shell_title "build_package: try_upgrade"
1460
1461 cd "$PACKAGE_DIR"
1462
1463 if [ "$UPGRADE_VERSION" ]; then
1464 TNEWVER=$UPGRADE_VERSION
1465 else
1466 if [ -n "$FLOAT_VERSION" ]; then
1467 TNOTIFY=$($APPDIR/pldnotify.awk ${BE_VERBOSE:+-vDEBUG=1} $SPECFILE -n) || exit 1
1468 else
1469 TNOTIFY=$($APPDIR/pldnotify.awk ${BE_VERBOSE:+-vDEBUG=1} $SPECFILE) || exit 1
1470 fi
1471
1472 # pldnotify.awk does not set exit codes, but it has match for ERROR
1473 # in output which means so.
1474 if [[ "$TNOTIFY" = *ERROR* ]]; then
1475 echo >&2 "$TNOTIFY"
1476 exit 1
1477 fi
1478
1479 TNEWVER=$(echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }')
1480 fi
1481
1482 if [ -n "$TNEWVER" ]; then
1483 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
1484 echo "New version found, updating spec file from $TOLDVER to version $TNEWVER"
1485 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1486 cp -f $SPECFILE $SPECFILE.bak
1487 fi
1488 chmod +w $SPECFILE
1489 set_release $SPECFILE $PACKAGE_RELEASE 1
1490 set_version $SPECFILE $PACKAGE_VERSION $TNEWVER
1491 parse_spec
1492 if [ "$PACKAGE_VERSION" != "$TNEWVER" ]; then
1493 echo >&2 "Upgrading version failed, you need to update spec yourself"
1494 exit 1
1495 fi
1496 return 1
1497 fi
1498 fi
1499 return 0
1500}
1501
1502build_package() {
1503 update_shell_title "build_package"
1504 if [ -n "$DEBUG" ]; then
1505 set -x
1506 set -v
1507 fi
1508
1509 cd "$PACKAGE_DIR"
1510
1511 case "$COMMAND" in
1512 build )
1513 BUILD_SWITCH="-ba" ;;
1514 build-binary )
1515 BUILD_SWITCH="-bb" ;;
1516 build-source )
1517 BUILD_SWITCH="-bs --nodeps" ;;
1518 build-prep )
1519 BUILD_SWITCH="-bp --nodeps" ;;
1520 build-build )
1521 BUILD_SWITCH="-bc" ;;
1522 build-install )
1523 BUILD_SWITCH="-bi" ;;
1524 build-list )
1525 BUILD_SWITCH="-bl" ;;
1526
1527 esac
1528
1529 update_shell_title "build_package: $COMMAND"
1530 if [ -n "$LOGFILE" ]; then
1531 LOG=`eval echo $LOGFILE`
1532 if [ -d "$LOG" ]; then
1533 echo "Log file $LOG is a directory."
1534 echo "Parse error in the spec?"
1535 Exit_error err_build_fail
1536 fi
1537 if [ -n "$LASTLOG_FILE" ]; then
1538 echo "LASTLOG=$LOG" > $LASTLOG_FILE
1539 fi
1540 RES_FILE=$(tempfile)
1541 local specdir=$(insert_gitlog $SPECFILE)
1542
1543 (time eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND --define \'_specdir $PACKAGE_DIR\' --define \'_sourcedir $PACKAGE_DIR\' $specdir/$SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
1544 RETVAL=`cat $RES_FILE`
1545 rm -r $RES_FILE $specdir
1546 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1547 if [ "$RETVAL" -eq "0" ]; then
1548 mv $LOG $LOGDIROK
1549 else
1550 mv $LOG $LOGDIRFAIL
1551 fi
1552 fi
1553 else
1554 local specdir=$(insert_gitlog $SPECFILE)
1555 eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND --define \'_specdir $PACKAGE_DIR\' --define \'_sourcedir $PACKAGE_DIR\' $specdir/$SPECFILE
1556 RETVAL=$?
1557 rm -r $specdir
1558 fi
1559 if [ "$RETVAL" -ne "0" ]; then
1560 if [ -n "$TRY_UPGRADE" ]; then
1561 echo "\nUpgrade package to new version failed."
1562 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1563 echo "Restoring old spec file."
1564 mv -f $SPECFILE.bak $SPECFILE
1565 fi
1566 echo ""
1567 fi
1568 Exit_error err_build_fail
1569 fi
1570 unset BUILD_SWITCH
1571}
1572
1573nourl() {
1574 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1575}
1576
1577install_required_packages() {
1578 run_poldek -vi $1
1579 return $?
1580}
1581
1582find_spec_bcond() { # originally from /usr/lib/rpm/find-spec-bcond
1583 local SPEC="$1"
1584 awk -F"\n" '
1585 /^%changelog/ { exit }
1586 /^%bcond_with/{
1587 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
1588 bcond = substr($0, RSTART + 6, RLENGTH - 6);
1589 gsub(/[ \t]+/, "_", bcond);
1590 print bcond
1591 }' $SPEC | LC_ALL=C sort -u
1592}
1593
1594process_bcondrc() {
1595 # expand bconds from ~/.bcondrc
1596 # The file structure is like gentoo's package.use:
1597 # ---
1598 # * -selinux
1599 # samba -mysql -pgsql
1600 # w32codec-installer license_agreement
1601 # php +mysqli
1602 # ---
1603 if [ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ]); then
1604 :
1605 else
1606 return
1607 fi
1608
1609 SN=${SPECFILE%%\.spec}
1610
1611 local bcondrc=$HOME/.bcondrc
1612 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
1613
1614 local bcond_avail=$(find_spec_bcond $SPECFILE)
1615
1616 while read pkg flags; do
1617 # ignore comments
1618 [[ "$pkg" == \#* ]] && continue
1619
1620 # any package or current package?
1621 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
1622 for flag in $flags; do
1623 local opt=${flag#[+-]}
1624
1625 # use only flags which are in this package.
1626 if [[ $bcond_avail = *${opt}* ]]; then
1627 if [[ $flag = -* ]]; then
1628 if [[ $BCOND != *--with?${opt}* ]]; then
1629 BCOND="$BCOND --without $opt"
1630 fi
1631 else
1632 if [[ $BCOND != *--without?${opt}* ]]; then
1633 BCOND="$BCOND --with $opt"
1634 fi
1635 fi
1636 fi
1637 done
1638 fi
1639 done < $bcondrc
1640 update_shell_title "parse ~/.bcondrc: DONE!"
1641}
1642
1643set_bconds_values() {
1644 update_shell_title "set bcond values"
1645
1646 AVAIL_BCONDS_WITHOUT=""
1647 AVAIL_BCONDS_WITH=""
1648
1649 if grep -Eq '^# *_with' ${SPECFILE}; then
1650 echo >&2 "ERROR: This spec has old style bconds."
1651 exit 1
1652 fi
1653
1654 if ! grep -q '^%bcond' ${SPECFILE}; then
1655 return
1656 fi
1657
1658 local bcond_avail=$(find_spec_bcond $SPECFILE)
1659 process_bcondrc "$SPECFILE"
1660
1661 update_shell_title "parse bconds"
1662
1663 local opt bcond
1664 for opt in $bcond_avail; do
1665 case "$opt" in
1666 without_*)
1667 bcond=${opt#without_}
1668 case "$BCOND" in
1669 *--without?${bcond}*)
1670 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$bcond>"
1671 ;;
1672 *)
1673 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $bcond"
1674 ;;
1675 esac
1676 ;;
1677 with_*)
1678 bcond=${opt#with_}
1679 case "$BCOND" in
1680 *--with?${bcond}*)
1681 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$bcond>"
1682 ;;
1683 *)
1684 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $bcond"
1685 ;;
1686 esac
1687 ;;
1688 *)
1689 echo >&2 "ERROR: unexpected '$opt' in set_bconds_values"
1690 exit 1
1691 ;;
1692 esac
1693 done
1694}
1695
1696run_sub_builder() {
1697 package_name="${1}"
1698 update_shell_title "run_sub_builder $package_name"
1699 #
1700